library benchpress.src.metric;

import "dart:async";
import "package:angular2/src/core/di.dart" show bind, provide, Provider;
import "package:angular2/src/facade/exceptions.dart"
    show BaseException, WrappedException;

/**
 * A metric is measures values
 */
abstract class Metric {
  static List<Provider> bindTo(delegateToken) {
    return [
      bind(Metric).toFactory((delegate) => delegate, [delegateToken])
    ];
  }

  /**
   * Starts measuring
   */
  Future<dynamic> beginMeasure() {
    throw new BaseException("NYI");
  }

  /**
   * Ends measuring and reports the data
   * since the begin call.
   * 
   */
  Future<Map<String, dynamic>> endMeasure(bool restart) {
    throw new BaseException("NYI");
  }

  /**
   * Describes the metrics provided by this metric implementation.
   * (e.g. units, ...)
   */
  Map<String, dynamic> describe() {
    throw new BaseException("NYI");
  }
}
